Index: branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h
===================================================================
--- branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 695)
+++ branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 696)
@@ -23,4 +23,5 @@
 #include "vci_simple_rom.h"
 #include "vci_xicu.h"
+#include "vci_local_crossbar.h"
 #include "dspin_local_crossbar.h"
 #include "vci_dspin_initiator_wrapper.h"
@@ -119,14 +120,14 @@
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_l2g_d;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_g2l_d;
+      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_l2g_d;
+      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_g2l_d;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_m2p_l2g_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_m2p_g2l_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_clack_l2g_c;
       DspinSignals<dspin_int_cmd_width> signal_int_dspin_clack_g2l_c;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_l2g_d;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_g2l_d;
       DspinSignals<dspin_int_rsp_width> signal_int_dspin_p2m_l2g_c;
       DspinSignals<dspin_int_rsp_width> signal_int_dspin_p2m_g2l_c;
 
-      // INT network VCI signals between VCI components and VCI/DSPIN wrappers
+      // INT network VCI signals between VCI components and VCI local crossbar
       VciSignals<vci_param_int> signal_int_vci_ini_proc[8];
       VciSignals<vci_param_int> signal_int_vci_ini_mdma;
@@ -140,25 +141,6 @@
       VciSignals<vci_param_int> signal_int_vci_tgt_iobx;
 
-      // INT network DSPIN signals between DSPIN local crossbars and VCI/DSPIN
-      // wrappers
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_proc_i[8];
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_proc_i[8];
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mdma_i;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mdma_i;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_iobx_i;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_iobx_i;
-
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_memc_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_memc_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_xicu_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_xicu_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_brom_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_brom_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mtty_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mtty_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_mdma_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_mdma_t;
-      DspinSignals<dspin_int_cmd_width> signal_int_dspin_cmd_iobx_t;
-      DspinSignals<dspin_int_rsp_width> signal_int_dspin_rsp_iobx_t;
+      VciSignals<vci_param_int> signal_int_vci_l2g;
+      VciSignals<vci_param_int> signal_int_vci_g2l;
 
       // Coherence DSPIN signals between DSPIN local crossbars and CC
@@ -205,25 +187,20 @@
 
       VciCcVCacheWrapperType*          proc[8];
-      VciIntDspinInitiatorWrapperType* proc_wi[8];
 
       VciMemCacheType*                 memc;
-      VciIntDspinTargetWrapperType*    memc_int_wt;
       VciExtDspinInitiatorWrapperType* memc_ram_wi;
 
       VciXicu<vci_param_int>*          xicu;
-      VciIntDspinTargetWrapperType*    xicu_int_wt;
 
       VciMultiDma<vci_param_int>*      mdma;
-      VciIntDspinInitiatorWrapperType* mdma_int_wi;
-      VciIntDspinTargetWrapperType*    mdma_int_wt;
 
       VciSimpleRom<vci_param_int>*     brom;
-      VciIntDspinTargetWrapperType*    brom_int_wt;
 
       VciMultiTty<vci_param_int>*      mtty;
-      VciIntDspinTargetWrapperType*    mtty_int_wt;
-
-      DspinLocalCrossbar<dspin_int_cmd_width>* int_xbar_cmd_d;
-      DspinLocalCrossbar<dspin_int_rsp_width>* int_xbar_rsp_d;
+
+      VciLocalCrossbar<vci_param_int>*  int_xbar_d;
+      VciIntDspinInitiatorWrapperType*  int_wi_gate_d;
+      VciIntDspinTargetWrapperType*     int_wt_gate_d;
+      
       DspinLocalCrossbar<dspin_int_cmd_width>* int_xbar_m2p_c;
       DspinLocalCrossbar<dspin_int_rsp_width>* int_xbar_p2m_c;
@@ -242,6 +219,4 @@
 
       VciIoBridge<vci_param_int, vci_param_ext>* iob;
-      VciIntDspinInitiatorWrapperType*           iob_int_wi;
-      VciIntDspinTargetWrapperType*              iob_int_wt;
       VciExtDspinInitiatorWrapperType*           iob_ram_wi;
 
Index: branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp
===================================================================
--- branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 695)
+++ branches/fault_tolerance/platform/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 696)
@@ -112,10 +112,4 @@
       proc[p]->set_dcache_paddr_ext_reset(cid);
       proc[p]->set_icache_paddr_ext_reset(cid);
-
-      std::ostringstream s_wi_proc;
-      s_wi_proc << "proc_wi_" << params.x_id << "_" << params.y_id << "_" << p;
-      proc_wi[p] = new VciIntDspinInitiatorWrapperType(
-            s_wi_proc.str().c_str(),
-            vci_param_int::S);
    }
 
@@ -138,10 +132,4 @@
          params.memc_debug_ok);
 
-   std::ostringstream s_wt_memc;
-   s_wt_memc << "memc_wt_" << params.x_id << "_" << params.y_id;
-   memc_int_wt = new VciIntDspinTargetWrapperType (
-         s_wt_memc.str().c_str(),
-         vci_param_int::S);
-
    std::ostringstream s_wi_memc;
    s_wi_memc << "memc_wi_" << params.x_id << "_" << params.y_id;
@@ -160,13 +148,6 @@
          X_WIDTH + Y_WIDTH);
 
-   std::ostringstream s_wt_brom;
-   s_wt_brom << "brom_wt_" << params.x_id << "_" << params.y_id;
-   brom_int_wt = new VciIntDspinTargetWrapperType (
-         s_wt_brom.str().c_str(),
-         vci_param_int::S);
-
    // Multi-TTY controller
    mtty        = NULL;
-   mtty_int_wt = NULL;
    if (NB_DEBUG_TTY_CHANNELS) {
       assert(NB_DEBUG_TTY_CHANNELS < 8);
@@ -185,10 +166,4 @@
             params.mt_int,
             vect_names);
-
-      std::ostringstream s_wt_mtty;
-      s_wt_mtty << "mtty_wt_" << params.x_id << "_" << params.y_id;
-      mtty_int_wt = new VciIntDspinTargetWrapperType (
-            s_wt_mtty.str().c_str(),
-            vci_param_int::S);
    }
 
@@ -203,10 +178,4 @@
          NB_PROCS);
 
-   std::ostringstream s_wt_xicu;
-   s_wt_xicu << "xicu_wt_" << params.x_id << "_" << params.y_id;
-   xicu_int_wt = new VciIntDspinTargetWrapperType (
-         s_wt_xicu.str().c_str(),
-         vci_param_int::S);
-
    ////////////  MDMA
    std::ostringstream s_mdma;
@@ -220,16 +189,4 @@
          NB_DMA_CHANNELS);
 
-   std::ostringstream s_wt_mdma;
-   s_wt_mdma << "mdma_wt_" << params.x_id << "_" << params.y_id;
-   mdma_int_wt = new VciIntDspinTargetWrapperType(
-         s_wt_mdma.str().c_str(),
-         vci_param_int::S);
-
-   std::ostringstream s_wi_mdma;
-   s_wi_mdma << "mdma_wi_" << params.x_id << "_" << params.y_id;
-   mdma_int_wi = new VciIntDspinInitiatorWrapperType(
-         s_wi_mdma.str().c_str(),
-         vci_param_int::S);
-
    ///////////  Direct LOCAL_XBAR(S)
    size_t nb_direct_initiators = NB_PROCS + 1;
@@ -243,31 +200,27 @@
    }
 
-   std::ostringstream s_int_xbar_cmd_d;
-   s_int_xbar_cmd_d << "int_xbar_cmd_d_" << params.x_id << "_" << params.y_id;
-   int_xbar_cmd_d = new DspinLocalCrossbar<dspin_int_cmd_width>(
-         s_int_xbar_cmd_d.str().c_str(),
-         params.mt_int,
-         params.x_id, params.y_id,
-         X_WIDTH, Y_WIDTH, l_width,
+   std::ostringstream s_int_xbar_d;
+   s_int_xbar_d << "int_xbar_cmd_d_" << params.x_id << "_" << params.y_id;
+   int_xbar_d = new VciLocalCrossbar<vci_param_int>(
+         s_int_xbar_d.str().c_str(),
+         params.mt_int,
+         cid,
          nb_direct_initiators,
          nb_direct_targets,
-         2, 2,
-         true,
-         true,
-         false);
-
-   std::ostringstream s_int_xbar_rsp_d;
-   s_int_xbar_rsp_d << "int_xbar_rsp_d_" << params.x_id << "_" << params.y_id;
-   int_xbar_rsp_d = new DspinLocalCrossbar<dspin_int_rsp_width>(
-         s_int_xbar_rsp_d.str().c_str(),
-         params.mt_int,
-         params.x_id, params.y_id,
-         X_WIDTH, Y_WIDTH, l_width,
-         nb_direct_targets,
-         nb_direct_initiators,
-         2, 2,
-         false,
-         false,
-         false);
+         0 );
+
+   std::ostringstream s_int_dspin_ini_wrapper_gate_d;
+   s_int_dspin_ini_wrapper_gate_d 
+      << "int_dspin_ini_wrapper_gate_d_" << params.x_id << "_" << params.y_id;
+   int_wi_gate_d = new VciIntDspinInitiatorWrapperType(
+         s_int_dspin_ini_wrapper_gate_d.str().c_str(),
+         X_WIDTH + Y_WIDTH + l_width);
+
+   std::ostringstream s_int_dspin_tgt_wrapper_gate_d;
+   s_int_dspin_tgt_wrapper_gate_d
+      << "int_dspin_tgt_wrapper_gate_d_" << params.x_id << "_" << params.y_id;
+   int_wt_gate_d = new VciIntDspinTargetWrapperType(
+         s_int_dspin_tgt_wrapper_gate_d.str().c_str(),
+         X_WIDTH + Y_WIDTH + l_width);
 
    ////////////  Coherence LOCAL_XBAR(S)
@@ -375,6 +328,4 @@
    ////////////////////// I/O  CLUSTER ONLY ///////////////////////
    iob        = NULL;
-   iob_int_wi = NULL;
-   iob_int_wt = NULL;
    iob_ram_wi = NULL;
    if ( is_io_cluster ) {
@@ -408,16 +359,4 @@
             params.iob_debug_ok );
 
-      std::ostringstream s_iob_int_wi;
-      s_iob_int_wi << "iob_int_wi_" << params.x_id << "_" << params.y_id;   
-      iob_int_wi = new VciIntDspinInitiatorWrapperType(
-            s_iob_int_wi.str().c_str(),
-            vci_param_int::S);
-
-      std::ostringstream s_iob_int_wt;
-      s_iob_int_wt << "iob_int_wt_" << params.x_id << "_" << params.y_id;   
-      iob_int_wt = new VciIntDspinTargetWrapperType(
-            s_iob_int_wt.str().c_str(),
-            vci_param_int::S);
-
       std::ostringstream s_iob_ram_wi;
       s_iob_ram_wi << "iob_ram_wi_" << params.x_id << "_" << params.y_id;   
@@ -467,57 +406,40 @@
    int_router_rsp->p_in[4][1]  (signal_int_dspin_p2m_l2g_c);
 
-   ///////////////////// CMD DSPIN  local crossbar direct
-   int_xbar_cmd_d->p_clk        (this->p_clk);
-   int_xbar_cmd_d->p_resetn     (this->p_resetn);
-   int_xbar_cmd_d->p_global_out (signal_int_dspin_cmd_l2g_d);
-   int_xbar_cmd_d->p_global_in  (signal_int_dspin_cmd_g2l_d);
-
-   int_xbar_cmd_d->p_local_out[INT_MEMC_TGT_ID] (signal_int_dspin_cmd_memc_t);
-   int_xbar_cmd_d->p_local_out[INT_XICU_TGT_ID] (signal_int_dspin_cmd_xicu_t);
-   int_xbar_cmd_d->p_local_out[INT_BROM_TGT_ID] (signal_int_dspin_cmd_brom_t);
-   int_xbar_cmd_d->p_local_out[INT_MDMA_TGT_ID] (signal_int_dspin_cmd_mdma_t);
+   ///////////////////// CMD & RSP VCI local crossbar direct
+   int_xbar_d->p_clk             (this->p_clk);
+   int_xbar_d->p_resetn          (this->p_resetn);
+   int_xbar_d->p_initiator_to_up (signal_int_vci_l2g);
+   int_xbar_d->p_target_to_up    (signal_int_vci_g2l);
+
+   int_xbar_d->p_to_target[INT_MEMC_TGT_ID] (signal_int_vci_tgt_memc);
+   int_xbar_d->p_to_target[INT_XICU_TGT_ID] (signal_int_vci_tgt_xicu);
+   int_xbar_d->p_to_target[INT_BROM_TGT_ID] (signal_int_vci_tgt_brom);
+   int_xbar_d->p_to_target[INT_MDMA_TGT_ID] (signal_int_vci_tgt_mdma);
    if (NB_DEBUG_TTY_CHANNELS) {
-      int_xbar_cmd_d->p_local_out[INT_MTTY_TGT_ID] (signal_int_dspin_cmd_mtty_t);
-   }
-   int_xbar_cmd_d->p_local_in[INT_MDMA_INI_ID]  (signal_int_dspin_cmd_mdma_i);
-
+      int_xbar_d->p_to_target[INT_MTTY_TGT_ID] (signal_int_vci_tgt_mtty);
+   }
+   int_xbar_d->p_to_initiator[INT_MDMA_INI_ID] (signal_int_vci_ini_mdma);
    for (size_t p = 0; p < NB_PROCS; p++) {
-      int_xbar_cmd_d->p_local_in[INT_PROC_INI_ID + p](
-            signal_int_dspin_cmd_proc_i[p]);
+      int_xbar_d->p_to_initiator[INT_PROC_INI_ID + p](
+            signal_int_vci_ini_proc[p]);
    }
 
    if ( is_io_cluster ) {
-      int_xbar_cmd_d->p_local_out[INT_IOBX_TGT_ID](
-            signal_int_dspin_cmd_iobx_t);
-      int_xbar_cmd_d->p_local_in[INT_IOBX_INI_ID](
-            signal_int_dspin_cmd_iobx_i);
-   }
-
-   //////////////////////// RSP DSPIN  local crossbar direct
-   int_xbar_rsp_d->p_clk        (this->p_clk);
-   int_xbar_rsp_d->p_resetn     (this->p_resetn);
-   int_xbar_rsp_d->p_global_out (signal_int_dspin_rsp_l2g_d);
-   int_xbar_rsp_d->p_global_in  (signal_int_dspin_rsp_g2l_d);
-
-   int_xbar_rsp_d->p_local_in[INT_MEMC_TGT_ID] (signal_int_dspin_rsp_memc_t);
-   int_xbar_rsp_d->p_local_in[INT_XICU_TGT_ID] (signal_int_dspin_rsp_xicu_t);
-   int_xbar_rsp_d->p_local_in[INT_BROM_TGT_ID] (signal_int_dspin_rsp_brom_t);
-   if (NB_DEBUG_TTY_CHANNELS) {
-      int_xbar_rsp_d->p_local_in[INT_MTTY_TGT_ID] (signal_int_dspin_rsp_mtty_t);
-   }
-   int_xbar_rsp_d->p_local_in[INT_MDMA_TGT_ID] (signal_int_dspin_rsp_mdma_t);
-
-   int_xbar_rsp_d->p_local_out[INT_MDMA_INI_ID](signal_int_dspin_rsp_mdma_i);
-   for (size_t p = 0; p < NB_PROCS; p++)
-      int_xbar_rsp_d->p_local_out[INT_PROC_INI_ID + p](
-            signal_int_dspin_rsp_proc_i[p]);
-
-   if ( is_io_cluster ) {
-      int_xbar_rsp_d->p_local_in[INT_IOBX_TGT_ID](
-            signal_int_dspin_rsp_iobx_t);
-      int_xbar_rsp_d->p_local_out[INT_IOBX_INI_ID](
-            signal_int_dspin_rsp_iobx_i);
-   }
-
+      int_xbar_d->p_to_target[INT_IOBX_TGT_ID]    (signal_int_vci_tgt_iobx);
+      int_xbar_d->p_to_initiator[INT_IOBX_INI_ID] (signal_int_vci_ini_iobx);
+   }
+
+   int_wi_gate_d->p_clk               (this->p_clk);
+   int_wi_gate_d->p_resetn            (this->p_resetn);
+   int_wi_gate_d->p_vci               (signal_int_vci_l2g);
+   int_wi_gate_d->p_dspin_cmd         (signal_int_dspin_cmd_l2g_d);
+   int_wi_gate_d->p_dspin_rsp         (signal_int_dspin_rsp_g2l_d);
+
+   int_wt_gate_d->p_clk               (this->p_clk);
+   int_wt_gate_d->p_resetn            (this->p_resetn);
+   int_wt_gate_d->p_vci               (signal_int_vci_g2l);
+   int_wt_gate_d->p_dspin_cmd         (signal_int_dspin_cmd_g2l_d);
+   int_wt_gate_d->p_dspin_rsp         (signal_int_dspin_rsp_l2g_d);
+   
    ////////////////////// M2P DSPIN local crossbar coherence
    int_xbar_m2p_c->p_clk              (this->p_clk);
@@ -562,10 +484,4 @@
          proc[p]->p_irq[j]    (signal_false);
       }
-
-      proc_wi[p]->p_clk       (this->p_clk);
-      proc_wi[p]->p_resetn    (this->p_resetn);
-      proc_wi[p]->p_dspin_cmd (signal_int_dspin_cmd_proc_i[p]);
-      proc_wi[p]->p_dspin_rsp (signal_int_dspin_rsp_proc_i[p]);
-      proc_wi[p]->p_vci       (signal_int_vci_ini_proc[p]);
    }
 
@@ -583,11 +499,4 @@
          xicu->p_hwi[i] (signal_false);
    }                     
-
-   // wrapper XICU
-   xicu_int_wt->p_clk       (this->p_clk);
-   xicu_int_wt->p_resetn    (this->p_resetn);
-   xicu_int_wt->p_dspin_cmd (signal_int_dspin_cmd_xicu_t);
-   xicu_int_wt->p_dspin_rsp (signal_int_dspin_rsp_xicu_t);
-   xicu_int_wt->p_vci       (signal_int_vci_tgt_xicu);
 
    ///////////////////////////////////// MEMC
@@ -601,11 +510,4 @@
    memc->p_irq              (signal_irq_memc);
 
-   // wrapper to INT network
-   memc_int_wt->p_clk       (this->p_clk);
-   memc_int_wt->p_resetn    (this->p_resetn);
-   memc_int_wt->p_dspin_cmd (signal_int_dspin_cmd_memc_t);
-   memc_int_wt->p_dspin_rsp (signal_int_dspin_rsp_memc_t);
-   memc_int_wt->p_vci       (signal_int_vci_tgt_memc);
-
    // wrapper to RAM network
    memc_ram_wi->p_clk       (this->p_clk);
@@ -620,11 +522,4 @@
    brom->p_vci              (signal_int_vci_tgt_brom);
 
-   //wrapper to INT network
-   brom_int_wt->p_clk       (this->p_clk);
-   brom_int_wt->p_resetn    (this->p_resetn);
-   brom_int_wt->p_dspin_cmd (signal_int_dspin_cmd_brom_t);
-   brom_int_wt->p_dspin_rsp (signal_int_dspin_rsp_brom_t);
-   brom_int_wt->p_vci       (signal_int_vci_tgt_brom);
-
    if (NB_DEBUG_TTY_CHANNELS) {
       //////////////////////////////////// MTTY
@@ -636,11 +531,4 @@
          mtty->p_irq[i] (signal_irq_mtty[i]);
       }
-
-      //wrapper to INT network
-      mtty_int_wt->p_clk       (this->p_clk);
-      mtty_int_wt->p_resetn    (this->p_resetn);
-      mtty_int_wt->p_dspin_cmd (signal_int_dspin_cmd_mtty_t);
-      mtty_int_wt->p_dspin_rsp (signal_int_dspin_rsp_mtty_t);
-      mtty_int_wt->p_vci       (signal_int_vci_tgt_mtty);
    }
 
@@ -664,18 +552,4 @@
    for (size_t i = 0 ; i < NB_DMA_CHANNELS ; i++)
       mdma->p_irq[i]        (signal_irq_mdma[i]);
-
-   // target wrapper
-   mdma_int_wt->p_clk       (this->p_clk);
-   mdma_int_wt->p_resetn    (this->p_resetn);
-   mdma_int_wt->p_dspin_cmd (signal_int_dspin_cmd_mdma_t);
-   mdma_int_wt->p_dspin_rsp (signal_int_dspin_rsp_mdma_t);
-   mdma_int_wt->p_vci       (signal_int_vci_tgt_mdma);
-
-   // initiator wrapper 
-   mdma_int_wi->p_clk       (this->p_clk);
-   mdma_int_wi->p_resetn    (this->p_resetn);
-   mdma_int_wi->p_dspin_cmd (signal_int_dspin_cmd_mdma_i);
-   mdma_int_wi->p_dspin_rsp (signal_int_dspin_rsp_mdma_i);
-   mdma_int_wi->p_vci       (signal_int_vci_ini_mdma);
 
    //////////////////////////// RAM network CMD & RSP routers
@@ -706,7 +580,9 @@
       iob->p_vci_ini_ram (signal_ram_vci_ini_iobx);
 
-      if ( is_iob0 )
-         for ( size_t n = 0 ; n < 32 ; n++ )
+      if ( is_iob0 ) {
+         for ( size_t n = 0 ; n < 32 ; n++ ) {
             (*iob->p_irq[n]) (*(this->p_irq[n]));
+         }
+      }
 
       // initiator wrapper to RAM network
@@ -716,18 +592,4 @@
       iob_ram_wi->p_dspin_rsp (*(this->p_dspin_iob_rsp_in));
       iob_ram_wi->p_vci       (signal_ram_vci_ini_iobx);
-
-      // initiator wrapper to INT network
-      iob_int_wi->p_clk       (this->p_clk);
-      iob_int_wi->p_resetn    (this->p_resetn);
-      iob_int_wi->p_dspin_cmd (signal_int_dspin_cmd_iobx_i);
-      iob_int_wi->p_dspin_rsp (signal_int_dspin_rsp_iobx_i);
-      iob_int_wi->p_vci       (signal_int_vci_ini_iobx);
-
-      // target wrapper to INT network
-      iob_int_wt->p_clk       (this->p_clk);
-      iob_int_wt->p_resetn    (this->p_resetn);
-      iob_int_wt->p_dspin_cmd (signal_int_dspin_cmd_iobx_t);
-      iob_int_wt->p_dspin_rsp (signal_int_dspin_rsp_iobx_t);
-      iob_int_wt->p_vci       (signal_int_vci_tgt_iobx);
    }
 } // end constructor
@@ -739,6 +601,4 @@
    if (p_dspin_iob_rsp_in)  delete p_dspin_iob_rsp_in;
    if (iob)                 delete iob;
-   if (iob_int_wi)          delete iob_int_wi;
-   if (iob_int_wt)          delete iob_int_wt;
    if (iob_ram_wi)          delete iob_ram_wi;
 
@@ -749,21 +609,13 @@
    for (size_t p = 0; p < NB_PROCS; p++) { 
       delete proc[p];
-      delete proc_wi[p];
    }
 
    delete memc;
-   delete memc_int_wt;
    delete memc_ram_wi;
    delete xicu;
-   delete xicu_int_wt;
    delete brom;
-   delete brom_int_wt;
    delete mtty;
-   delete mtty_int_wt;
    delete mdma;
-   delete mdma_int_wt;
-   delete mdma_int_wi;
-   delete int_xbar_cmd_d;
-   delete int_xbar_rsp_d;
+   delete int_xbar_d;
    delete int_xbar_m2p_c;
    delete int_xbar_p2m_c;